//+------------------------------------------------------------------+
//|                                                   Timeseries.mq5 |
//|                                                            IgorM |
//|                            https://login.mql5.com/ru/users/IgorM |
//+------------------------------------------------------------------+
#property copyright "IgorM"
#property link      "https://login.mql5.com/ru/users/IgorM"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
class Timeseries{
   public:
      datetime    Time[];     // -,       
      double      Open[];     // -,       .
      double      High[];     // -,       .
      double      Low[];      // -,       .
      double      Close[];    // -,       .
      Timeseries(string symbol,ENUM_TIMEFRAMES period, int bars){
            _symbol  = symbol;
            _bars    = bars;
            _period  = period;
            copytimeseries();
      };
      void refresh(){
            MqlTick TICK;
            SymbolInfoTick(_symbol,TICK);
            datetime lastbar_time = (datetime)SeriesInfoInteger(_symbol,_period,SERIES_LASTBAR_DATE);
            if (Time[0] != lastbar_time) copytimeseries(); else Close[0] = TICK.bid;
      }
   private:
      string            _symbol;
      int               _bars;
      ENUM_TIMEFRAMES   _period;
      void              copytimeseries(){
                              CopyTime(_symbol,_period,0,_bars,Time);
                              CopyOpen(_symbol,_period,0,_bars,Open);
                              CopyHigh(_symbol,_period,0,_bars,High);
                              CopyLow(_symbol,_period,0,_bars,Low);
                              CopyClose(_symbol,_period,0,_bars,Close);
                        }
};
//+------------------------------------------------------------------+

void OnStart(){
   Timeseries MQL4(_Symbol,PERIOD_CURRENT,100);
   for(int i =0;i<100;i++){
      string s = (string)MQL4.Time[i]+" : "+(string)MQL4.Open[i]+" / "+(string)MQL4.High[i]+" / "+
                 (string)MQL4.Low[i] +" / "+(string)MQL4.Close[i];
      Print(s);
   }   
}
//+------------------------------------------------------------------+
